------------------------------------------------------------------------
-- An example making use of the minimum function
------------------------------------------------------------------------

module Minimum.Example where

open import Data.Bool
open import Data.Fin
open import Data.Fin.Props
open import Data.Function
open import Data.Nat hiding (_≤?_)
open import Data.Nat.Properties
open import Data.Vec

open import Thunk
import Minimum

_≤?_ : forall {n} -> (i j : Fin n) -> Thunk (1 + (toℕ i ⊓ toℕ j)) Bool
zero  ≤? _     = √ return true
suc i ≤? suc j = √ i ≤? j
suc i ≤? zero  = √ return false

_≤?′_ : forall {n} -> Fin n -> Fin n -> Thunk (4 + n) Bool
_≤?′_ {n} i j = √ wait-≤ lem (i ≤? j)
  where
  open import Relation.Binary
  trans = Poset.trans ℕ-poset

  lem : 1 + (toℕ i ⊓ toℕ j) ≤ 1 + n
  lem = s≤s $ m⊓n≤m (toℕ i) (toℕ j)
          ⟨ trans ⟩
        ≤pred⇒≤ (toℕ i) n (prop-toℕ-≤ i)

open module Example = Minimum {Fin 3} _≤?′_

test : Fin 3
test = force (minimum (suc zero ∷ suc (suc zero) ∷ zero ∷ []))
