-- # import prelude
-- # import nat
-- # import thunk

-- Debit passing thunk.

-- A value of type
--   DPThunk debitSteps steps debits a
-- stands for a thunk containing a value of type a. The thunk takes
-- "steps" time steps to evaluate, and the evaluation discharges
-- "debits" debits, where each debit is worth debitSteps time steps.

DPThunk : (debitSteps, steps, debits : ℕ) -> Set -> Set
DPThunk debitSteps steps debits a =
  Thunk (steps + debits * debitSteps) a

-- It could be nice to let the definition above be abstract. In that
-- case the functions below (plus a monad instance, and maybe more)
-- are necessary.

toThunk (debitSteps, steps, debits : ℕ) (a : Set)
  :  DPThunk debitSteps steps debits a
  -> Thunk (steps + debits * debitSteps) a
toThunk = id

liftThunk (debitSteps, n : ℕ) (a : Set)
  : Thunk n a -> DPThunk debitSteps n 0 a
liftThunk = id
